<?php

function redirect_out_of_stock_product() {
    if (!function_exists('is_product') || !function_exists('wc_get_product')) {
        return;
    }

    if (is_product()) {
        global $post;
        $product = wc_get_product($post->ID);

        if ($product && !$product->is_in_stock()) {
            $categories = get_the_terms($product->get_id(), 'product_cat');
            
            if (!empty($categories) && !is_wp_error($categories)) {
                usort($categories, function($a, $b) {
                    return strcmp($a->name, $b->name);
                });

                $first_category = array_shift($categories);
                $category_link = get_term_link($first_category->term_id, 'product_cat');

                if (!is_wp_error($category_link)) {
                    wp_redirect($category_link);
                    exit;
                }
            }
        }
    }
}